package com.muzhi.meixi.APITest;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.muzhi.meixi.api.WdtClient;
import com.muzhi.meixi.service.AccessTokenService;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@SpringBootTest
public class Test1 {

    @Autowired
    private AccessTokenService accessTokenService;

    @Test
    public void panduan(){
        //判断日期是否为周六周日
        String date = "2022-10-08 00:00:00";
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date date1 = null;
        try {
            date1 = format.parse(date);
            System.out.println("date1：" + date1);
        }catch (Exception e){
            e.printStackTrace();
        }
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date1);

        if (calendar.get(Calendar.DAY_OF_WEEK)==Calendar.SATURDAY||calendar.get(Calendar.DAY_OF_WEEK)==Calendar.SUNDAY){
            System.out.println("当前日期为周六周日！");
        }else {
            System.out.println("当前日期为工作日");
        }
    }

    @Test
    public void date(){
        int dkcs = 5;
        int ccts = 0;

        dkcs = dkcs/2;
        int dkcsLast = (int)dkcs;


        if (dkcs > 0){
            //实际出差天数
            ccts = ccts + dkcsLast;
            System.out.println("实际出差天数：" + ccts);
        }

        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        long startLong = new Long("1670342400000");
        //将时间戳转换为时间
        Date startDate = new Date(startLong);
        System.out.println("出差开始时间（时间型）：" + startDate);
        //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
        String startString = simpleDateFormat.format(startDate);
        System.out.println("出差开始时间（时间样式）：" + startString);

        long endLong = new Long("1670428800000");
        //将时间戳转换为时间
        Date endDate = new Date(endLong);
        System.out.println("出差结束时间（时间型）：" + endDate);
        //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
        String endString = simpleDateFormat.format(endDate);
        System.out.println("出差结束时间（时间样式）：" + endString);

        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(endDate);
        //后面一天
        calendar1.add(Calendar.DAY_OF_MONTH,1);
        calendar1.set(Calendar.HOUR_OF_DAY,0);
        calendar1.set(Calendar.MINUTE,0);
        calendar1.set(Calendar.SECOND,0);
        calendar1.set(Calendar.MILLISECOND,0);
        String time1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar1.getTime());
        System.out.println("出差结束时间后面一天零点：" + time1);

        DateTime lastDateTime = DateUtil.parse(time1);
        System.out.println("出差结束时间后面一天（时间型）：" + lastDateTime);

        //获取当天前一天的零点零分零秒
        Date Date = new Date(System.currentTimeMillis());
        System.out.println("当前时间：" + Date);
        String dateNowString = simpleDateFormat.format(Date);
        System.out.println("当前时间（时间样式）：" + dateNowString);

        Calendar calendar = Calendar.getInstance();
        calendar.setTime(Date);
        //前一天
        calendar.add(Calendar.DAY_OF_MONTH,-1);
        calendar.set(Calendar.HOUR_OF_DAY,0);
        calendar.set(Calendar.MINUTE,0);
        calendar.set(Calendar.SECOND,0);
        calendar.set(Calendar.MILLISECOND,0);
        String time = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar.getTime());
        System.out.println("前一天零点：" + time);

        Calendar calendar111 = Calendar.getInstance();
        calendar111.setTime(Date);
        //前一个月第一天
        calendar111.add(Calendar.MONTH,-1);
        calendar111.set(Calendar.DAY_OF_MONTH,1);
        calendar111.set(Calendar.HOUR_OF_DAY,0);
        calendar111.set(Calendar.MINUTE,0);
        calendar111.set(Calendar.SECOND,0);
        calendar111.set(Calendar.MILLISECOND,0);
        String FORMtime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar111.getTime());
        System.out.println("前一个月第一天零点：" + FORMtime);

        Calendar calendar222 = Calendar.getInstance();
        int month222 = calendar222.get(Calendar.MONTH);
        //前一个月最后一天
        calendar222.set(Calendar.MONTH,month222-1);
        calendar222.set(Calendar.DAY_OF_MONTH,calendar222.getActualMaximum(Calendar.DAY_OF_MONTH));
        calendar222.set(Calendar.HOUR_OF_DAY,0);
        calendar222.set(Calendar.MINUTE,0);
        calendar222.set(Calendar.SECOND,0);
        calendar222.set(Calendar.MILLISECOND,0);
        String TOtime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar222.getTime());
        System.out.println("前一个月最后一天零点：" + TOtime);
    }

    @Test
    public void wangdiantong(){

        //卖家账号
        String sid = "xindi2";
        //接口账号
        String appkey = "xindi2-ot";
        //接口秘钥
        String appsecret = "7aaa92c1cb4b8c00d42082b5d430c55a";
        //正式环境
        String baseUrl = "https://api.wangdian.cn/openapi2/";


        //卖家账号
        String sidTest = "apidevnew2";
        //接口账号
        String appkeyTest = "xindi2-test";
        //接口秘钥
        String appsecretTest = "bff3980d2";
        //测试环境
        String baseUrlTest = "https://sandbox.wangdian.cn/openapi2/";

        //正式
        WdtClient client = new WdtClient(sid, appkey, appsecret, baseUrl);

        //测试
//        WdtClient client = new WdtClient(sidTest, appkeyTest, appsecretTest, baseUrlTest);

        //测试环境sid、appkey、密钥请到旺店通开放平台-自助对接-申请测试环境内查看，测试环境url=https://sandbox.wangdian.cn/openapi2/
        //调用正式环境时请将sid、appkey、appsecret切换为实际参数，参数在旺店通开放平台-自助对接-应用管理内应用状态为已上线的应用中查看，调用正式环境注意切换正式环境url=https://api.wangdian.cn/openapi2/

        Map<String, String> params = new HashMap<>();
        //CANGK
//        params.put("warehouse_no", "WARE1");
//        params.put("start_time","2022-11-01 00:00:00");
//        params.put("end_time","2022-11-29 00:00:00");
        params.put("page_no", "0");
        params.put("page_size", "100");


        //【全量查询库存接口】
//        JSONObject jsonObject = null;
//        try {
//            String response = client.execute("vip_stock_query_all.php", params);
//            System.out.println(response);
//
//            jsonObject = JSON.parseObject(response);
//
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

        //【增量查询库存接口】
        params.put("start_time", "2022-12-01 00:00:00");
        params.put("end_time", "2022-12-13 00:00:00");
//        params.put("spec_no","6930285735967");
        params.put("is_deleted","1");
//        params.put("spec_is_deleted","1");

        JSONObject jsonObject = null;
        try {
            String response = client.execute("stock_query.php", params);
            System.out.println(response);

            jsonObject = JSON.parseObject(response);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        System.out.println("旺店通接口返回数据：" + jsonObject);

//        //unicode转中文
//        int start = 0;
//        int end = 0;
//        final StringBuffer buffer = new StringBuffer();
//        while (start > -1) {
//            end = message.indexOf("\\u", start + 2);
//            String charStr = "";
//            if (end == -1) {
//                charStr = message.substring(start, message.length());
//            } else {
//                charStr = message.substring(start, end);
//            }
//            char letter = (char) Integer.parseInt(charStr, 16); // 16进制parse整型字符串。
//            buffer.append(new Character(letter).toString());
//            start = end;
//        }
//        String messageStr = buffer.toString();
//        System.out.println("unicode转中文：" + messageStr);

//        JSONArray stocks = jsonObject.getJSONArray("stocks");
//        for (int i = 0; i < stocks.size(); i++) {
//            JSONObject jsonObject1 = stocks.getJSONObject(i);
//            //条形码
//            String barcode = jsonObject1.getString("barcode");
//            //货物名称
//            String goods_name = jsonObject1.getString("goods_name");
//            //仓库名称
//            String warehouse_name = jsonObject1.getString("warehouse_name");
//            //库存量
//            String stock_num = jsonObject1.getString("stock_num");
//        }
    }
}