package com.muzhi.meixi.entity;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;


@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "库存信息", description = "美犀旺店通库存信息")
public class Stocks {

    @ApiModelProperty(value = "条形码")
    private String barcode;

    @ApiModelProperty(value = "货品编码")
    private String goodsNo;

    @ApiModelProperty(value = "货品名称")
    private String goodsName;

    @ApiModelProperty(value = "仓库主键id")
    private String warehouseId;

    @ApiModelProperty(value = "仓库编码")
    private String warehouseNo;

    @ApiModelProperty(value = "仓库名称")
    private String warehouseName;

    @ApiModelProperty(value = "库存量")
    private float stockNum;

    @ApiModelProperty(value = "产品编码")
    private String cpbm;

    @ApiModelProperty(value = "通用小名")
    private String tyxm;

    @ApiModelProperty(value = "国内加总")
    private float gnjz;

    @ApiModelProperty(value = "日销")
    private float rx;

    @ApiModelProperty(value = "剩余售卖天数")
    private float sysmts;

    @ApiModelProperty(value = "当前剩余库存")
    private float dqsykc;

    @ApiModelProperty(value = "下月剩余库存")
    private float xysykc;

    @ApiModelProperty(value = "预估断货日")
    private Date ygdhr;
}
