package com.muzhi.meixi.entity;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;


@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "库存信息", description = "美犀旺店通库存展示信息")
public class StocksCopy {

    @ApiModelProperty(value = "条形码")
    private String barcode;

    @ApiModelProperty(value = "货品编码")
    private String goodsNo;

    @ApiModelProperty(value = "货品名称")
    private String goodsName;


    /*======仓库======*/
    @ApiModelProperty(value = "奇门菜鸟仓编码048")
    private String qmcncNo;

    @ApiModelProperty(value = "奇门菜鸟仓名称")
    private String qmcncName;

    @ApiModelProperty(value = "奇门菜鸟仓存量")
    private float qmcncNum;

    @ApiModelProperty(value = "天猫仓编码020")
    private String tmcNo;

    @ApiModelProperty(value = "天猫仓名称")
    private String tmcName;

    @ApiModelProperty(value = "天猫仓库存量")
    private float tmcNum;

    @ApiModelProperty(value = "网红仓编码021")
    private String whcNo;

    @ApiModelProperty(value = "网红仓名称")
    private String whcName;

    @ApiModelProperty(value = "网红仓库存量")
    private float whcNum;

    @ApiModelProperty(value = "分销仓编码022")
    private String fxcNo;

    @ApiModelProperty(value = "分销仓名称")
    private String fxcName;

    @ApiModelProperty(value = "分销仓库存量")
    private float fxcNum;

    @ApiModelProperty(value = "备用仓编码023")
    private String bycNo;

    @ApiModelProperty(value = "备用仓名称")
    private String bycName;

    @ApiModelProperty(value = "备用仓库存量")
    private float bycNum;

    @ApiModelProperty(value = "次品仓编码024")
    private String cpcNo;

    @ApiModelProperty(value = "次品仓名称")
    private String cpcName;

    @ApiModelProperty(value = "次品仓库存量")
    private float cpcNum;

    @ApiModelProperty(value = "徐汇仓编码025")
    private String xhcNo;

    @ApiModelProperty(value = "徐汇仓名称")
    private String xhcName;

    @ApiModelProperty(value = "徐汇仓库存量")
    private float xhcNum;

    @ApiModelProperty(value = "广州仓编码026")
    private String gzcNo;

    @ApiModelProperty(value = "广州仓名称")
    private String gzcName;

    @ApiModelProperty(value = "广州仓库存量")
    private float gzcNum;

    @ApiModelProperty(value = "直营仓编码033")
    private String zycNo;

    @ApiModelProperty(value = "直营仓名称")
    private String zycName;

    @ApiModelProperty(value = "直营仓库存量")
    private float zycNum;

    @ApiModelProperty(value = "广州次品仓编码059")
    private String gzcpcNo;

    @ApiModelProperty(value = "广州次品仓名称")
    private String gzcpcName;

    @ApiModelProperty(value = "广州次品仓库存量")
    private float gzcpcNum;

    @ApiModelProperty(value = "暂存仓编码060")
    private String zccNo;

    @ApiModelProperty(value = "暂存仓名称")
    private String zccName;

    @ApiModelProperty(value = "暂存仓库存量")
    private float zccNum;
    /*======仓库======*/


    @ApiModelProperty(value = "产品编码")
    private String cpbm;

    @ApiModelProperty(value = "通用小名")
    private String tyxm;

    @ApiModelProperty(value = "国内加总")
    private float gnjz;

    @ApiModelProperty(value = "日销")
    private float rx;

    @ApiModelProperty(value = "剩余售卖天数")
    private float sysmts;

    @ApiModelProperty(value = "当前剩余库存")
    private float dqsykc;

    @ApiModelProperty(value = "下月剩余库存")
    private float xysykc;

    @ApiModelProperty(value = "预估断货日")
    private Date ygdhr;

    @ApiModelProperty(value = "本月剩余天数")
    private int bysyts;

    @ApiModelProperty(value = "下月总天数")
    private int xyzts;
}
