package com.muzhi.meixi.service.impl;

import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.request.OapiGettokenRequest;
import com.dingtalk.api.response.OapiGettokenResponse;
import com.muzhi.meixi.service.AccessTokenService;
import com.taobao.api.ApiException;
import org.springframework.stereotype.Service;


/**
 * @Author ZhangKan
 * @Data 15:39
 */

@Service
public class AccessTokenServiceImpl implements AccessTokenService {

    //美犀
    //APPKEY
    private static String APPKEY = "dingfzex4b8uyuvgo0ap";
    //APPSECRET
    private static String APPSECRET = "GAO61byMYd5EjMQT9zoLMn-3e4qWMJBcxzwBrXa5Z8cGn_BJUr3KntW1dbgbS_jY";
    //AgenthId:2184795806

    public static String accessToken = null;


    //获取access_token的方法（美犀架构）
    @Override
    public String getAccessToken() {
        DefaultDingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/gettoken");
        OapiGettokenRequest request = new OapiGettokenRequest();
        request.setAppkey(APPKEY);
        request.setAppsecret(APPSECRET);
        request.setHttpMethod("GET");
        try {
            OapiGettokenResponse response = client.execute(request);
            accessToken = response.getAccessToken();
            System.out.println("AccessToken：" + accessToken);
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return accessToken;
    }
}
